library flutterurlpreview;

import 'package:flutter/material.dart';
import 'package:flutterurlpreview/model.dart';
import 'package:flutterurlpreview/utils.dart';

class LinkPreview extends StatefulWidget {
  final Widget child;
  final Color backgroundColor;
  final Widget leading;
  final Widget trailing;

  final TextEditingController controller;
  final TextCapitalization textCapitalization;
  final TextInputType keyboardType;
  final int maxLines;
  final InputDecoration decoration;

  LinkPreview(
      {@required this.child,
      @required this.controller,
      this.backgroundColor,
      this.leading,
      this.trailing,
      this.textCapitalization,
      this.keyboardType,
      this.maxLines,
      this.decoration});

  @override
  _LinkPreviewState createState() => _LinkPreviewState();
}

class _LinkPreviewState extends State<LinkPreview> {
  LinkData data;

  void getLinkData(String url) async {
    data = await checkAndGetLinkData(url);
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      child: Column(
        children: <Widget>[
          Expanded(child: widget.child),
          Container(
            color: widget.backgroundColor ?? Colors.grey.shade300,
            child: Column(
              children: <Widget>[
                widget.leading,
                Expanded(
                  child: TextField(
                    controller: widget.controller,
                    textCapitalization: widget.textCapitalization ??
                        TextCapitalization.sentences,
                    onChanged: (value) => getLinkData(value),
                    keyboardType:
                        widget.keyboardType ?? TextInputType.multiline,
                    maxLines: widget.maxLines ?? null,
                    decoration: widget.decoration,
//                      InputDecoration(
//                        filled: true,
//                        border: OutlineInputBorder(
//                            borderRadius:
//                            BorderRadius.all(Radius.circular(24.0)),
//                            borderSide: BorderSide.none),
//                        fillColor: Colors.white,
//                        contentPadding: EdgeInsets.symmetric(
//                            vertical: 10.0, horizontal: 16.0),
//                        hintText: 'Send a message...',
//                      )
                  ),
                ),
                widget.trailing
              ],
            ),
          )
        ],
      ),
    );
  }
}
